SystemOrganization addCategory: #'Moe-Magritte'!

MAToManyRelationDescription subclass: #MOEmbeddedCollectionDescription
	instanceVariableNames: 'objectClass collectionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedCollectionDescription commentStamp: 'jmck 6/12/2009 14:59' prior: 0!
I am a convenience description. I return true for isEmbeddedCollection so you don't have of to send beEmbeddedCollection (but you still have to type EmbeddedCollection!!). I also have a useless objectClass method that is supposed to be a convenience but only serves to confuse issues further lol

The author is still deciding whether or not to toss me like he has the rest of his bloated framework!

!MOEmbeddedCollectionDescription class methodsFor: 'as yet unclassified' stamp: 'jmck 6/12/2009 15:09'!
defaultCollectionClass
	^OrderedCollection! !

!MOEmbeddedCollectionDescription class methodsFor: 'as yet unclassified' stamp: 'JohnMcKeon 10/23/2011 17:25'!
defaultComponentClass
	^MOOneToManyComponent! !

!MOEmbeddedCollectionDescription methodsFor: 'testing' stamp: 'jmck 6/12/2009 14:52'!
isEmbeddedCollection
	^true! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing' stamp: 'jmck 7/4/2009 12:30'!
objectClass
	^objectClass ifNil: [^self classes first ]! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing' stamp: 'jmck 1/12/2011 23:23'!
objectClass: aClass
	"Set the value of objectClass"

	objectClass := aClass.
	classes := (Array with: aClass) ! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing-properties' stamp: 'jmck 7/26/2009 21:00'!
sqlColumnType
	^'integer[]'! !

MACheckedMemento subclass: #MOMemento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOMemento methodsFor: 'actions' stamp: 'jmck 2/10/2010 22:28'!
push: aDictionary
	"handle removed children"
	| originalChildren |
	aDictionary keysAndValuesDo: [ :key :value |
		key isEmbeddedCollection 
			ifTrue: [originalChildren := self model readUsing: key.
				value = originalChildren 
					ifFalse: [originalChildren do: [ :child |
							(value indexOf: child) = 0 ifTrue: [ child delete ]]]]].
	super push: aDictionary.! !

!MOMemento methodsFor: 'actions' stamp: 'jmck 2/10/2010 22:46'!
reset
	"delete added children"
	| originalChildren |
	cache isNil ifFalse: [
		cache keysAndValuesDo: [ :key :value |
			key isEmbeddedCollection 
				ifTrue: [originalChildren := self model readUsing: key.
					value = originalChildren 
						ifFalse: [value do: [ :child |
							(originalChildren indexOf: child) = 0
								ifTrue: [ child delete ]]]]]].
	super reset.! !

MAToOneRelationDescription subclass: #MOEmbeddedObjectDescription
	instanceVariableNames: 'objectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedObjectDescription commentStamp: 'jmck 6/12/2009 14:57' prior: 0!
I am a convenience description. I return true for isEmbedded ao you don;t have of to send beEmbeddedCollection (but you still have to type EmbeddedCollection!!). I also have a useless objectClass method that is supposed to be a convenience but only serves to confuse issues further lol

I do implement componentClass which returns a nifty lookup component.

The author is still deciding whether or not to toss me like he has the rest of his bloated framework!

!MOEmbeddedObjectDescription class methodsFor: 'as yet unclassified' stamp: 'jmck 2/15/2010 18:50'!
defaultComponentClass
	^MOSelectComponent! !

!MOEmbeddedObjectDescription methodsFor: 'visiting' stamp: 'jmck 10/12/2009 09:13'!
acceptMagritte: aVisitor
	aVisitor visitElementDescription: self! !

!MOEmbeddedObjectDescription methodsFor: 'testing' stamp: 'jmck 6/12/2009 14:51'!
isEmbedded
	^true! !

!MOEmbeddedObjectDescription methodsFor: 'accessing' stamp: 'jmck 6/11/2009 23:09'!
objectClass
	"Answer the value of objectClass"

	^ objectClass ifNil: [ self classes first ]! !

!MOEmbeddedObjectDescription methodsFor: 'accessing' stamp: 'jmck 1/12/2011 23:24'!
objectClass: aClass
	"Set the value of objectClass"

	objectClass := aClass.
	classes := Array with: aClass! !

!MOEmbeddedObjectDescription methodsFor: 'accessing-properties' stamp: 'jmck 7/26/2009 20:59'!
sqlColumnType
	^'integer'! !

MAPriorityContainer subclass: #MOContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOContainer commentStamp: 'jmck 6/12/2009 14:57' prior: 0!
I exist to point to an MOEmbeddedContainerComponent which saves the model to the DB after commiting the memento to the model.!

!MOContainer methodsFor: 'accessing' stamp: 'jmck 2/9/2010 19:52'!
componentClass
	^MOContainerComponent! !

MOContainer subclass: #MORowContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MORowContainer methodsFor: 'accessing' stamp: 'jmck 2/1/2011 20:09'!
componentRenderer
	^MORowRenderer! !

MAOneToManyComponent subclass: #MOOneToManyComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOOneToManyComponent methodsFor: 'as yet unclassified' stamp: 'jmck 9/5/2011 01:57'!
remove: anObject
	"Moe one-to-many models have to stay in sync with memento"
	self value remove: anObject.
	self refresh! !
